###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2005 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define kernel_version 2.6.9-22.0.1.EL
%define subversion 37

%ifnarch i686 x86_64 athlon
%define buildsmp 0
%endif 

%ifnarch i686
%define buildhugemem 0
%endif

Name: dlm-kernel
Version: 2.6.9
Release: 37.9
License: GPL
Group: System Environment/Kernel
Summary: dlm-kernel - The Distributed Lock Manager kernel modules.
BuildRequires: cman-kernheaders >= 2.6.9
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: kernel-hugemem-devel = %{kernel_version}
BuildRequires: cman-kernel >= 2.6.9
BuildRequires: cman-kernel-smp >= 2.6.9
BuildRequires: cman-kernel-hugemem >= 2.6.9
Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-module-smp GFS-module-hugemem
Requires: kernel = %{kernel_version}
Requires: cman-kernel >= 2.6.9
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64
Source0: %{name}-%{version}-%{subversion}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dlm-kernel - The Distributed Lock Manager kernel modules.

%package -n dlm-kernheaders
Group: Development/System
Summary: dlm kernel header files

%description -n dlm-kernheaders
The dlm kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n dlm-kernel-smp
Group: System Environment/Kernel
Summary: dlm-kernel-smp - The Distributed Lock Manager kernel modules.
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Requires: cman-kernel-smp >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-smp
dlm-kernel-smp - The Distributed Lock Manager kernel-smp modules.
%endif

%if %{buildhugemem}
%package -n dlm-kernel-hugemem
Group: System Environment/Kernel
Summary: dlm-kernel-hugemem - The Distributed Lock Manager kernel modules.
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Requires: cman-kernel-hugemem >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-hugemem
dlm-kernel-hugemem - The Distributed Lock Manager kernel-hugemem modules.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
       src/dlm_internal.h	
################################################################################
##  THE BUILD SECTION
################################################################################
%build

ROOT_DIR_FILES=`ls`
mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem

Build_dlm(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build/
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make symverfile=/lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	$kernel_src/scripts/mod/modpost -m -i /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers src/dlm.o -o dlm.symvers
}

%if %{buildup}
cd up
Build_dlm %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_dlm %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_dlm %{_target_cpu} hugemem
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
cd ..
%endif
                                                                                
%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}smp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}hugemem/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}hugemem/kernel/cluster/
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n dlm-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildhugemem}
%files -n dlm-kernel-hugemem
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}hugemem/kernel/cluster/*
%endif

%files -n dlm-kernheaders
%defattr(-,root,root,-)
%{_includedir}/cluster/*

%changelog
* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provide dlm-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file. 

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Fri Oct 22 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- add requires field

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp was building but not being packaged
- specify more packages that conflict with this one

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- no need for make file patch

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- update patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- add patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- be more explicit in files section

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev number and fix typo

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
